#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_WXYaoQingCFG.h"
std::auto_ptr<M_WXYaoQingCFG> M_WXYaoQingCFG::msSingleton(nullptr);

int M_WXYaoQingCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_WXYaoQingCFGData* M_WXYaoQingCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_WXYaoQingCFGData>& M_WXYaoQingCFG::GetMapData()
{
	return mMapData;
}

void M_WXYaoQingCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_WXYaoQingCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_WXYaoQingCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mDesInvitation = element->Attribute("DesInvitation");
		data.mNumberCompleted = element->IntAttribute("NumberCompleted");
		{
			const char* Ward = element->Attribute("Ward");
			std::vector<std::string> vecWard;
			boost::split(vecWard, Ward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecWard.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecWard[i].c_str(), &temp))
				{
					data.mWard.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_WXYaoQingCFG Loaded. Load Data:%u", mMapData.size());
}

void M_WXYaoQingCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_WXYaoQingCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_WXYaoQingCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_WXYaoQingCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "DesInvitation", data.mDesInvitation);
		LuaCfgHelper::readInt(L, "NumberCompleted", data.mNumberCompleted);
		LuaCfgHelper::readVectorInt(L, "Ward", data.mWard);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_WXYaoQingCFG Loaded. Load Data:%u", mMapData.size());
}

void M_WXYaoQingCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_WXYaoQingCFG* M_WXYaoQingCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_WXYaoQingCFG());
	}
	return msSingleton.get();
}

void M_WXYaoQingCFG::Release()
{
	msSingleton.reset(nullptr);
}
